﻿using System;

using Prism.Commands;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우 뷰 모델
    /// </summary>
    public class MainWindowViewModel : ICloseWindow
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 닫기 명령
        /// </summary>
        private DelegateCommand closeComand;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 닫기 명령 - CloseCommand

        /// <summary>
        /// 닫기 명령
        /// </summary>
        public DelegateCommand CloseCommand => this.closeComand ?? (this.closeComand = new DelegateCommand(ProcessCloseCommand));

        #endregion

        #region 닫기 액션 - CloseAction

        /// <summary>
        /// 닫기 액션
        /// </summary>
        public Action CloseAction { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 닫기 가능 여부 구하기 - CanClose()

        /// <summary>
        /// 닫기 가능 여부 구하기
        /// </summary>
        /// <returns>닫기 가능 여부</returns>
        public bool CanClose()
        {
            return true;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 닫기 명령 처리하기 - ProcessCloseCommand()

        /// <summary>
        /// 닫기 명령 처리하기
        /// </summary>
        private void ProcessCloseCommand()
        {
            CloseAction?.Invoke();
        }

        #endregion
    }
}